﻿/*
 * Készítette a SharpDevelop.
 * Felhasználó: phil
 * Dátum: 2010.01.22.
 * Idő: 16:12
 * 
 * A sablon megváltoztatásához használja az Eszközök | Beállítások | Kódolás | Szabvány Fejlécek Szerkesztését.
 */
using System;
using System.Drawing;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization;
using System.Windows.Forms.DataVisualization.Charting;

namespace System.Windows.Forms.DataVisualization
{
	/// <summary>
	/// Description of MSChartFormatter.
	/// </summary>
	public static class MSChartFormatter
	{
		static string numberFormat = "n2";
		static Font numberFont = null;
		static Font titleFont = null;
		static ChartDashStyle gridDashStyle = ChartDashStyle.Dot;
		
		
		public static string NumberFormat {
			get { return numberFormat; }
			set { numberFormat = value; }
		}
		
		public static Font NumberFont {
			get { return numberFont; }
			set { numberFont = value; }
		}
		
		public static Font TitleFont {
			get { return titleFont; }
			set { titleFont = value; }
		}
		
		public static ChartDashStyle GridDashStyle {
			get { return gridDashStyle; }
			set { gridDashStyle = value; }
		}
		
		
		public static void Format(Chart chart)
		{
			if (numberFont == null) numberFont = new Font(chart.Font.FontFamily, 10.0f, FontStyle.Regular, GraphicsUnit.Point);
			if (titleFont == null) titleFont = new Font(chart.Font.FontFamily, 12.0f, FontStyle.Regular, GraphicsUnit.Point);
			
			chart.ChartAreas[0].AxisX.IntervalAutoMode = IntervalAutoMode.FixedCount;
			chart.ChartAreas[0].AxisX.LabelStyle.Format = numberFormat;
			chart.ChartAreas[0].AxisX.LabelStyle.Font = numberFont;
			chart.ChartAreas[0].AxisX.LabelAutoFitStyle = LabelAutoFitStyles.None;
			chart.ChartAreas[0].AxisX.TitleFont = titleFont;
			chart.ChartAreas[0].AxisX.MajorGrid.LineDashStyle = gridDashStyle;
			//
			chart.ChartAreas[0].AxisY.IntervalAutoMode = IntervalAutoMode.VariableCount;
			chart.ChartAreas[0].AxisY.LabelStyle.Format = numberFormat;
			chart.ChartAreas[0].AxisY.LabelStyle.Font = numberFont;
			chart.ChartAreas[0].AxisY.LabelAutoFitStyle = LabelAutoFitStyles.None;
			chart.ChartAreas[0].AxisY.TitleFont = titleFont;
			chart.ChartAreas[0].AxisY.MajorGrid.LineDashStyle = gridDashStyle;
		}
	}
}
