﻿/*
 * Készítette a SharpDevelop.
 * Felhasználó: phil
 * Dátum: 2009.11.21.
 * Idő: 14:40
 * 
 * A sablon megváltoztatásához használja az Eszközök | Beállítások | Kódolás | Szabvány Fejlécek Szerkesztését.
 */
using System;
using System.Collections;
using System.Collections.Generic;

namespace Noise.DataAcquisition
{
	/// <summary>
	/// A queue of double values from a single input channel, along with the channel information.
	/// </summary>
	public class ChannelData : Queue<double>, IChannelDataSocket<double>
	{
		protected ChannelInfo channelInfo;
		protected object syncRoot;
		protected double currentValue;
		
		public ChannelData(ChannelInfo channelInfo) : base()
		{
			this.channelInfo = channelInfo;
			syncRoot = (this as ICollection).SyncRoot;
		}
		
		public ChannelInfo ChannelInfo {
			get { return channelInfo; }
		}
		
		public double CurrentValue {
			get { return currentValue; }
		}
		
		
		public object SyncRoot {
			get { return syncRoot; }
		}
		
		new public void Enqueue(double item)
		{
			currentValue = (channelInfo.Sensor != null) ? channelInfo.Sensor.GetValue(item) : item;
			base.Enqueue(currentValue);
		}
	}
}
