﻿/*
 * Készítette a SharpDevelop.
 * Felhasználó: Ouroboros
 * Dátum: 2010.02.28.
 * Idő: 14:43
 * 
 * A sablon megváltoztatásához használja az Eszközök | Beállítások | Kódolás | Szabvány Fejlécek Szerkesztését.
 */
using System;
using System.Collections;
using System.Collections.Generic;

namespace Noise.DataAcquisition
{
	/// <summary>
	/// Description of ChannelDataSocketCollection.
	/// </summary>
	public class ChannelDataSocketCollection : List<IChannelDataSocket<double>>
	{
		protected object syncRoot;
		
		
		public ChannelDataSocketCollection() : base()
		{
			syncRoot = (this as ICollection).SyncRoot;
		}
		
		
		public object SyncRoot {
			get { return syncRoot; }
		}
		
		
		public double[] Dequeue()
		{
			double[] item = new double[this.Count];
			
			for (int i = 0; i < item.Length; i++) {
				lock (this[i].SyncRoot) {
					item[i] = this[i].Dequeue();
				}
			}
			
			return item;
		}
		
		public int GetChannelDataCount()
		{
			List<int> counts = new List<int>();
			int count = Int32.MaxValue;
			
			foreach (IChannelDataSocket<double> channel in this) {
				lock (channel.SyncRoot) { // TODO: Possible deadlock location.
					counts.Add(channel.Count);
				}
			}
			
			foreach (int item in counts) {
				if (item < count) count = item;
			}
			
			return count;
		}
	}
}
