/*
 * Created by SharpDevelop.
 * User: phil
 * Date: 2010.02.19.
 * Time: 15:15
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;

namespace TetheredSun.SignalAnalysis
{
	/// <summary>
	/// Description of Cycle.
	/// </summary>
	public class LevelCrossingCycle
	{
		protected double upCrossing;
		protected double downCrossing;
		protected double nextUpCrossing;
	
		
		public LevelCrossingCycle(double upCrossing, double downCrossing, double nextUpCrossing)
		{
			this.upCrossing = upCrossing;
			this.downCrossing = downCrossing;
			this.nextUpCrossing = nextUpCrossing;
		}
		
		public LevelCrossingCycle(double upCrossing, double downCrossing) : this(upCrossing, downCrossing, Double.NaN) { }
		
		public LevelCrossingCycle(double upCrossing) : this(upCrossing, Double.NaN, Double.NaN) { }
		
		public LevelCrossingCycle() : this(Double.NaN, Double.NaN, Double.NaN) { }

		
		public double UpCrossing {
			get { return upCrossing; }
			set { upCrossing = value; }
		}
		
		public double DownCrossing {
			get { return downCrossing; }
			set { downCrossing = value; }
		}
		
		public double NextUpCrossing {
			get { return nextUpCrossing; }
			set { nextUpCrossing = value; }
		}
		
		public double Period {
			get { return nextUpCrossing - upCrossing; }
		}
		
		public double PulseWidth {
			get { return downCrossing - upCrossing; }
		}
	}
}
