/*
 * Created by SharpDevelop.
 * User: phil
 * Date: 2010.02.19.
 * Time: 15:58
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections;
using System.Collections.Generic;
//
using TetheredSun.Core;

namespace TetheredSun.SignalAnalysis
{
	/// <summary>
	/// Description of LevelCrossingCycleCollection.
	/// </summary>
	public class LevelCrossingCycleCollection : RingBuffer<LevelCrossingCycle>
	{
		public LevelCrossingCycleCollection(int capacity) : base(capacity) { }
		
		
		public LevelCrossingCycleCollection() : base(16) { }
		
		
		public override void Add(LevelCrossingCycle item)
		{
			base.Add(item);
			if (this.Count > 1) {
				this[this.Count - 2].NextUpCrossing = item.UpCrossing;
			}
		}
		
		public void AddRange(IEnumerable<LevelCrossingCycle> collection)
		{
			foreach (LevelCrossingCycle item in collection) {
				this.Add(item);
			}
		}
	}
}
